'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _utils = require('kenga/utils');

var _utils2 = _interopRequireDefault(_utils);

var _widget = require('kenga/widget');

var _widget2 = _interopRequireDefault(_widget);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ImageParagraph = function (_Widget) {
    _inherits(ImageParagraph, _Widget);

    function ImageParagraph(aElement, text, image, iconTextGap) {
        _classCallCheck(this, ImageParagraph);

        if (arguments.length < 4) iconTextGap = 4;
        if (arguments.length < 3) icon = null;
        if (arguments.length < 2) text = '';

        var _this = _possibleConstructorReturn(this, (ImageParagraph.__proto__ || Object.getPrototypeOf(ImageParagraph)).call(this, aElement));

        var self = _this;

        var horizontalTextPosition = _utils2.default.HorizontalPosition.RIGHT;
        var verticalTextPosition = _utils2.default.VerticalPosition.CENTER;

        var paragraph = document.createElement('p');
        paragraph.classList.add('p-paragraph');
        _this.element.appendChild(paragraph);

        _this.element.classList.add('p-image-paragraph');

        function applyPosition() {
            self.element.classList.remove('p-image-paragraph-column');
            self.element.classList.remove('p-image-paragraph-row');
            self.element.classList.remove('p-image-paragraph-row-top');
            self.element.classList.remove('p-image-paragraph-row-bottom');
            if (image) {
                image.style.marginLeft = '';
                image.style.marginRight = '';
                image.style.marginTop = '';
                image.style.marginBottom = '';
            }
            if (horizontalTextPosition === _utils2.default.HorizontalPosition.CENTER) {
                self.element.classList.add('p-image-paragraph-column');
                if (verticalTextPosition === _utils2.default.VerticalPosition.TOP) {
                    if (image) {
                        self.element.insertBefore(paragraph, image);
                        if (iconTextGap > 0 && text) image.style.marginTop = iconTextGap + 'px';
                    }
                } else if (verticalTextPosition === _utils2.default.VerticalPosition.BOTTOM || verticalTextPosition === _utils2.default.VerticalPosition.CENTER) {
                    if (image) {
                        self.element.insertBefore(image, paragraph);
                        if (iconTextGap > 0 && text) image.style.marginBottom = iconTextGap + 'px';
                    }
                } // else // value of 'verticalTextPosition' is unknown
            } else {
                self.element.classList.add('p-image-paragraph-row');
                if (horizontalTextPosition === _utils2.default.HorizontalPosition.LEFT) {
                    if (image) {
                        self.element.insertBefore(paragraph, image);
                        if (iconTextGap > 0 && text) image.style.marginLeft = iconTextGap + 'px';
                    }
                } else if (horizontalTextPosition === _utils2.default.HorizontalPosition.RIGHT) {
                    if (image) {
                        self.element.insertBefore(image, paragraph);
                        if (iconTextGap > 0 && text) image.style.marginRight = iconTextGap + 'px';
                    }
                } // else // value of 'horizontalTextPosition' is unknown
                if (verticalTextPosition === _utils2.default.VerticalPosition.TOP) {
                    self.element.classList.add('p-image-paragraph-row-top');
                } else if (verticalTextPosition === _utils2.default.VerticalPosition.BOTTOM) {
                    self.element.classList.add('p-image-paragraph-row-bottom');
                } // else // value of 'verticalTextPosition' is unknown
            }
        }

        function applyText() {
            paragraph.innerText = text;
        }

        applyPosition();
        applyText();

        function iconByString(aValue) {
            var img = document.createElement('img');
            img.src = aValue;
            return img;
        }

        Object.defineProperty(_this, 'icon', {
            get: function get() {
                return image;
            },
            set: function set(aValue) {
                if (image !== aValue) {
                    if (image) {
                        image.classList.remove('p-image');
                        self.element.removeChild(image);
                    }
                    image = typeof aValue === 'string' ? iconByString(aValue) : aValue;
                    if (image) {
                        self.element.appendChild(image);
                        image.classList.add('p-image');
                        applyPosition();
                    }
                }
            }
        });
        Object.defineProperty(_this, 'text', {
            get: function get() {
                return text;
            },
            set: function set(aValue) {
                if (text !== aValue) {
                    text = aValue;
                    applyText();
                }
            }
        });
        Object.defineProperty(_this, 'iconTextGap', {
            get: function get() {
                return iconTextGap;
            },
            set: function set(aValue) {
                iconTextGap = aValue;
            }
        });
        /**
         * Horizontal position of the text relative to the icon.
         */
        Object.defineProperty(_this, 'horizontalTextPosition', {
            get: function get() {
                return horizontalTextPosition;
            },
            set: function set(aValue) {
                if (horizontalTextPosition !== aValue) {
                    horizontalTextPosition = aValue;
                    applyPosition();
                }
            }
        });

        /**
         * Vertical position of the text relative to the icon.
         */
        Object.defineProperty(_this, 'verticalTextPosition', {
            get: function get() {
                return verticalTextPosition;
            },
            set: function set(aValue) {
                if (verticalTextPosition !== aValue) {
                    verticalTextPosition = aValue;
                    applyPosition();
                }
            }
        });
        return _this;
    }

    return ImageParagraph;
}(_widget2.default);

exports.default = ImageParagraph;